#ifndef LANDSCAPEAREA_H
#define LANDSCAPEAREA_H

#include <QWidget>
#include <QPaintEvent>
#include <QPainter>
//#include <QTimer>

#include <math.h>

#include "common.h"

class LandscapeArea : public QWidget
{
    Q_OBJECT

public:
    LandscapeArea(QWidget *parent = 0);
    void LandscapeArea_setup(int*, int (*community)[GENOME_BITS]);

public slots:
   void slot_LandscapeUpdate(void);  // Once per press of Run, Amplitude, Shift, or
                                     // anything that changes the landscape.
   void slot_EnvironmentUpdate(void);// Once for each time to redraw the Environment.
   void slot_MMRsUpdate(void);       // Every read the genome and redraw the MMRs.
   void slot_ClearHistory(void);     // FIXME: Function not yet implemented.

signals:

protected:
    // This virtual function is called by Qt whenever a widget needs to update itself.
    void paintEvent(QPaintEvent *event);

private:
    void paintEnvironment(QPainter &painter);
    void paintLandscape(QPainter &painter);
    void paintMemberMarkers(QPainter &painter);

    QRect EnvironmentRect() const;
    QRect MemberMarkersRect() const;
    QRect HistoryRect() const;

    int* ptr_to_environment ;
    int (*ptr_to_community)[GENOME_BITS] ; 

};

#endif
